// Local
import '/models/tracked_type.dart';
import '/models/frequency.dart';

abstract class RecurringTrackedType extends TrackedType {
  Frequency frequency;

  RecurringTrackedType({
    super.id,
    required super.name,
    required super.amount,
    required this.frequency,
    required super.description,
  });

  double calcComparableAmountYearly() {
    return amount * frequency.timesPerYear;
  }

  double calcComparableAmountDaily() {
    return amount / frequency.numDays;
  }

  @override
  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'name': name,
      'amount': amount,
      'frequency': frequency.title,
      'description': description,
    };
  }
}
